#include "Xbp.ch"
#include "Appevent.ch"
#include "Gra.CH"

//
// missing in ot4xb.ch
//
#Define PBST_NORMAL        0x0001
#Define PBST_ERROR         0x0002
#Define PBST_PAUSED        0x0003

#Define PBS_MARQUEE        0x08
#Define PBS_SMOOTH         0x01
#Define PBS_NORMAL         0

PROCEDURE AppSys()
RETURN

PROCEDURE Main()
LOCAL nEvent, mp1, mp2, oXbp
LOCAL oDlg
LOCAL aSize := {640,200}
LOCAL oProgress
LOCAL obp1,obp2,obp3
LOCAL oThread
LOCAL nEvery
LOCAL i := 0

   oDlg := XbpDialog():New( AppDesktop() )
   oDlg:Title       := "native XbpProgressBar"
   oDlg:TaskList    := .T.
   oDlg:icon        := 1

   oDlg:drawingArea:clipChildren := .T.

   oDlg:Create(AppDeskTop(),,,aSize,, .F. )

   * -------------------------------------------------------------------- *

   oProgress := DXE_ProgressBar():New( oDlg:DrawingArea,, {10,100}, {aSize[1]-20,50} )
   //
   // these Option must be set before create()
   //
   oProgress:UseVisualStyle := .T.
   oProgress:UsePercent     := .F.
   //
   oProgress:Create()
   //
   // set Style after create()
   //

IF PCOUNT() > 0
   oProgress:Style := PBS_MARQUEE
   IF oProgress:Style = PBS_MARQUEE
      // make faster
      oProgress:SetMarqueeSpeed( 10 )
   ENDIF
ELSE
   oProgress:Style := PBS_SMOOTH
ENDIF

   //
   oProgress:Minimum := 0
   oProgress:Maximum := 1000

   // do not "paint" every time (slow)
   // just every 1% so Scale is 100%
   //
   nEvery := INT(oProgress:Maximum/100)

   // Sample DBF
   //
   // xMax     := Lastrec()
   // nEvery   := INT(xMax/100)
   // xScale   := xMax*nEvery     // Scale to 100%
   //
   //

   oProgress:nScaleMax := oProgress:Maximum * nEvery

   * -------------------------------------------------------------------- *

   obp1 := XbpPushButton():new(oDlg:DrawingArea, , {10, 4}, {610,30} )
   obp1:caption := "normal Color"
   obp1:create()
   obp1:activate:= {|| SetProgressState(oProgress,1) }

   obp2 := XbpPushButton():new(oDlg:DrawingArea, , {10,36}, {610,30} )
   obp2:caption := "Pause Color"
   obp2:create()
   obp2:activate:= {|| SetProgressState(oProgress,2) }

   obp3 := XbpPushButton():new(oDlg:DrawingArea, , {10,68}, {610,30} )
   obp3:caption := "Error Color"
   obp3:create()
   obp3:activate:= {|| SetProgressState(oProgress,3) }

   SetAppFocus( obp3 )

   oThread := Thread():New()
   //
   // use Random Interval for each Thread
   //
   oThread:SetInterval( 5 )
   oThread:Start( {|| ProgressThreadFunc(oProgress,nEvery,i++) } )

   CenterControl( oDlg )
   oDlg:Show()
   oProgress:Show()
   SetAppFocus( oDlg )

   nEvent := xbeP_None
   DO WHILE nEvent != xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      DO CASE
         CASE nEvent == xbeP_Keyboard .AND. mp1 == xbeK_ALT_F4
            EXIT

      OTHERWISE
         oXbp:HandleEvent( nEvent, mp1, mp2 )
      ENDCASE
   ENDDO


RETURN

PROCEDURE ProgressThreadFunc( oProgress,nEvery,i)
LOCAL nValue := oProgress:GetData()

   IF ((i) % (nEvery)) == 0
      nValue := oProgress:GetData()
      nValue += nEvery

      IF nValue >= oProgress:Maximum
         nValue := oProgress:Minimum
      ENDIF

      oProgress:SetData( nValue )
   ENDIF
RETURN


PROCEDURE SetProgressState(oProgress,nValue)

   IF oProgress:IsMarquee()
      //
      // do not switch oProgress:State ... will slow down
      //
   ELSE
      DO CASE
         CASE nValue = 1
            //
            // Color GREEN
            //
            oProgress:State := PBST_NORMAL

         CASE nValue = 2
            //
            // Color YELLOW
            //
            oProgress:State := PBST_PAUSED

         CASE nValue = 3
            //
            // Color RED
            //
            oProgress:State := PBST_ERROR
      ENDCASE
   ENDIF

RETURN



